import java.util.*;

class ThreadPool 
{
	private static final int MAX_THREADS = 100;
	private static final int MIN_THREADS = 30;
  private LinkedList m_pool;
  private int size;
  private int maxThreads;
  
  
  public ThreadPool(int poolSize){
  	if(poolSize > 0)
  		size = poolSize;
  }
  /**
  *	Inizializza il pool, ed avvia tutti i thread.<br>
  *
  */
  public synchronized void initializePool(){
    if(m_pool == null)
     	m_pool = new LinkedList();
     	
    if(size == 0)
    	size = MIN_THREADS;
    if(maxThreads == 0)
    	maxThreads = MAX_THREADS;	
    if(size > maxThreads)
     	size = maxThreads;	
     	
    for(int i = 0;i < size; i ++)
  	{  		
  		//avvia il thread
  		ClientManager cm = new ClientManager(this);
  		//aggiunge il thread, gi avviato, al pool
  		m_pool.add(cm);	
  	}	
  }
  
 /**
  *	Il metodo estrae i thread dal pool con il metodo FIFO.<br>
  *	
  *	@return ClientManager il thread che gestir la risposta al client.<br>
  *	@throws InterruptedException se succede qualche imprevisto 
  *	durante l'eventuale attesa.<br>
  */
	public synchronized ClientManager getClientManager()throws InterruptedException{
	  
	  while (m_pool.size() < 0)
	  	Thread.sleep(100);
	  		
	  return (ClientManager)m_pool.removeFirst();
	 
	}
	
 /**
	*	il metodo rimette il thread che ha finito il suo lavoro
	*	all'ultimo posto nmella lista.<br>
	*
	*	@param	ClinetManager cm il thread da rimettere nel pool
	*/
	public synchronized void returnThreadToPool(ClientManager cm){
	 
	 	m_pool.addLast(cm);
	 
	}
	
	
	
	public synchronized void closePool(){
		
		ListIterator li = m_pool.listIterator();
		while(li.hasNext()){
		 ClientManager cm = (ClientManager)li.next();
		 cm.stopManager();
		 li.remove();
		}
   System.out.println("m_pool.size() = "+m_pool.size());			
	
	}
	
	
	/***********************************************************************
	 * Metodi di servizio																							 *								       *
	 ***********************************************************************/
	public void setMaxThreads(int maxThreads){
	  this.maxThreads = maxThreads;
	}
	
	public void setNumThreads(int numThreads){
	  size = numThreads;
	}
	
}