import java.io.*;

public class ClientManager extends Thread
{
	
	private InputStream iS = null;
	private OutputStream oS = null;
	private boolean controlExecution = false;
	private boolean m_toRun;
	public boolean server_toRun;
	private ThreadPool manager;
	private Server server;
	private final String ROOT_SERVER_DIRECTORY = "c:\\server\\docs";
	
	public ClientManager(ThreadPool tp){
			manager = tp;
			start();
			m_toRun = true;
	}
	
	/**
	*	inizializza il thread ad ogni, comunicandogli il suo pool di riferimento, 
	*	e gli stream per gestire la richiesta.<br>
	*
	*	@parameter InputStream is lo stream che contiene la richiesta.<br>
	*	@parameter OutputSTream os lo stream per la risposta.<br>
	*/ 
	public synchronized void init(Server srv,InputStream is, OutputStream os){
	   iS = is;
	   oS = os;
	   server = srv;
	   controlExecution = true;
	   //notify();
	}
	
	
	/**
	*	ridefinizione del metodo run().<br>
	*/
	public void run(){
	  try{
	    while(m_toRun){	
		  	while (! controlExecution)
		  		sleep(100);
		  	manageRequest();
	    }	
	  }
	  catch(InterruptedException ie){
	    ie.printStackTrace();
	  } 	
	}
	
	/**
	*	questo metodo si prende carico della richiesta e cerca di gestirla.<br>
	*/
	public void manageRequest(){ 
	 try{  
	  //buffer per la richiesta
		byte b[] = new byte[iS.available()];
		iS.read(b);
		String request = new String(b); 
	  System.out.println("client request>"+request);
	  answerRequest(request);
	  
	 }
	 catch(Exception e)
	 {
	   e.printStackTrace();		
	 }
	 finally{
	 	//questo thread ritorna al suo posto da solo
	 	manager.returnThreadToPool(this);
	 	controlExecution = false;
	 }   
	}
		
	/**
	*	il metodo risponde al client che ha fatto una richiesta.<br>
	*
	*/
	private void answerRequest(String request){
		
		
		if(request.startsWith("shutdown"))
			server.stopServer();
		else{		
		//cerco la GET
		//subito dopo la get c' l'indirizzo della risorsa richiesta
			try{
				int start = request.indexOf("GET")+4;
				int end = request.indexOf(" ",start);
				String requestedResource = request.substring(start,end);
				System.out.println("requested resource: "+requestedResource);
				requestedResource = requestedResource.replace('/',File.separatorChar);
				//System.out.println("requested resource2: "+requestedResource);
				FileInputStream fis = new FileInputStream(ROOT_SERVER_DIRECTORY+requestedResource);
				byte[] buffer = new byte[fis.available()];
				fis.read(buffer);
				
				oS.write(buffer);
				oS.flush();
				oS.close();
				}
				catch(IOException ioe){
				 ioe.printStackTrace();
				}
		}	
	}
	
	public synchronized void stopManager(){
	  m_toRun = false;
	}
				
}